
enum items {
	ITEM_AIR         = 0x0,
	ITEM_DIRT        = 0x1,
	ITEM_DIAMOND     = 0x2,
	ITEM_BOULDER     = 0x3,
	ITEM_WALL        = 0x4,
	ITEM_MAGIC_WALL  = 0x5,
	ITEM_STEEL_WALL  = 0x6,
	ITEM_EXIT        = 0x7,
	ITEM_PLAYER      = 0x8,
	ITEM_AMOEBA      = 0x9,
	ITEM_BUTTERFLY   = 0xA,
	ITEM_FIREFLY     = 0xB,

	ITEM_COUNT,

	ITEM_BITS = 4,
	ITEM_MASK = 0x0F,
};

enum item_properties {
	PROPERTY_ANIMATED            = /*10000000*/0x80,
	PROPERTY_INITIALLY_HIDDEN    = /*01000000*/0x40,
	PROPERTY_EXPLODES_IF_CRUSHED = /*00100000*/0x20,
	PROPERTY_BREAKABLE           = /*00010000*/0x10,
	PROPERTY_AFFECTED_BY_GRAVITY = /*00001000*/0x08,
	PROPERTY_SOAPY               = /*00000100*/0x04,
	PROPERTY_PLAYER_CAN_GOTO     = /*00000010*/0x02,
	PROPERTY_PUSHABLE            = /*00000001*/0x01,
};

uint8_t item_properties(uint8_t item);
